> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Create an e-invoice file template

POST https://rest.test.zuora.com/v1/einvoice/templates
Content-Type: application/json

Creates an e-invoice file templates for your billing documents, including invoices, credit memos, and debit memos.

Zuora provides default e-invoice file templates, so you can just customize them as needed. For example, some country specific fields like HSN (Harmonized System of Nomenclature) might be stored on product rate plan charges.

**Note**: This operation is available only if you have the E-Invoicing feature in **Early Adopter** phase enabled.

Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/billing-documents/e-invoicing/post-create-e-invoice-file-template

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

### Body (application/json)

This endpoint expects a CreateEInvoiceFileTemplateRequest.

- `content` (string, required) — The content of the e-invoice file template, which must be encoded in Base64 format.
- `country` (string, required) — The short name of a country or region where you must comply with e-invoicing requirements. For example, `IN` for India. For the full list of country names and codes, see View countries or regions.
- `documentType` (enum, required) — The type of billing documents, which the e-invoice file template is intended for.
  - Allowed values: `Invoice`, `CreditMemo`, `DebitMemo`
- `name` (string, required) — The name of the e-invoice file template.
- `provider` (enum, required) — The name of an e-invoicing service provider that assists in generating e-invoice files.
  - Allowed values: `Sovos`

## Response

### 200

OK

- `content` (string, optional) — The content of the e-invoice file template, which must be encoded in Base64 format.
- `country` (boolean, optional) — The short name of a country or region where you must comply with e-invoicing requirements. For example, `IN` for India. For the full list of country names and codes, see View countries or regions.
- `documentType` (enum, optional) — The type of billing document for which the e-invoice file template is intended.
  - Allowed values: `Invoice`, `CreditMemo`, `DebitMemo`
- `id` (string, optional) — The unique ID of the e-invoice file template.
- `name` (string, optional) — The name of the e-invoice file template.
- `provider` (enum, optional) — The name of the e-invoicing service provider that assists in generating e-invoice files for billing documents.
  - Allowed values: `Sovos`
- `templateNumber` (string, optional) — The unique number of the e-invoice file template.

## Errors

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 400 Client Request Error

Request Errors

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

## Examples

**Request**

```json
{
  "content": "base64 encoded content",
  "country": "IN",
  "documentType": "Invoice",
  "name": "Sovos e-invoice service",
  "provider": "Sovos"
}
```

**Response**

```json
{
  "content": "base64 encoded content",
  "country": true,
  "documentType": "Invoice",
  "id": "4028818484f483d20184f5006b97003f",
  "name": "Sovos e-invoice service",
  "provider": "Sovos",
  "templateNumber": "EITEMP-00000003",
  "success": true
}
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/v1/einvoice/templates"

payload = {
    "content": "base64 encoded content",
    "country": "IN",
    "documentType": "Invoice",
    "name": "Sovos e-invoice service",
    "provider": "Sovos"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/v1/einvoice/templates';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"content":"base64 encoded content","country":"IN","documentType":"Invoice","name":"Sovos e-invoice service","provider":"Sovos"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/einvoice/templates"

	payload := strings.NewReader("{\n  \"content\": \"base64 encoded content\",\n  \"country\": \"IN\",\n  \"documentType\": \"Invoice\",\n  \"name\": \"Sovos e-invoice service\",\n  \"provider\": \"Sovos\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/einvoice/templates")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"content\": \"base64 encoded content\",\n  \"country\": \"IN\",\n  \"documentType\": \"Invoice\",\n  \"name\": \"Sovos e-invoice service\",\n  \"provider\": \"Sovos\"\n}"

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/v1/einvoice/templates")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"content\": \"base64 encoded content\",\n  \"country\": \"IN\",\n  \"documentType\": \"Invoice\",\n  \"name\": \"Sovos e-invoice service\",\n  \"provider\": \"Sovos\"\n}")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/v1/einvoice/templates', [
  'body' => '{
  "content": "base64 encoded content",
  "country": "IN",
  "documentType": "Invoice",
  "name": "Sovos e-invoice service",
  "provider": "Sovos"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/einvoice/templates");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"content\": \"base64 encoded content\",\n  \"country\": \"IN\",\n  \"documentType\": \"Invoice\",\n  \"name\": \"Sovos e-invoice service\",\n  \"provider\": \"Sovos\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "content": "base64 encoded content",
  "country": "IN",
  "documentType": "Invoice",
  "name": "Sovos e-invoice service",
  "provider": "Sovos"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/einvoice/templates")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```